/* connection.c generated by valac 0.10.0, the Vala compiler
 * generated from connection.vala, do not modify */

/*
 * indicator-network - user interface for connman
 * Copyright 2010-2011 Canonical Ltd.
 *
 * Authors:
 * Andrew Higginson
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 3, as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <stdio.h>


#define TYPE_WIFI_CONNECTION (wifi_connection_get_type ())
#define WIFI_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WIFI_CONNECTION, WifiConnection))
#define WIFI_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WIFI_CONNECTION, WifiConnectionClass))
#define IS_WIFI_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WIFI_CONNECTION))
#define IS_WIFI_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WIFI_CONNECTION))
#define WIFI_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WIFI_CONNECTION, WifiConnectionClass))

typedef struct _WifiConnection WifiConnection;
typedef struct _WifiConnectionClass WifiConnectionClass;
typedef struct _WifiConnectionPrivate WifiConnectionPrivate;

#define TYPE_WIRELESS_MODE (wireless_mode_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_DEVICE (device_get_type ())
#define DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEVICE, Device))
#define DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEVICE, DeviceClass))
#define IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEVICE))
#define IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEVICE))
#define DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEVICE, DeviceClass))

typedef struct _Device Device;
typedef struct _DeviceClass DeviceClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _WifiConnection {
	GObject parent_instance;
	WifiConnectionPrivate * priv;
};

struct _WifiConnectionClass {
	GObjectClass parent_class;
};

typedef enum  {
	WIRELESS_MODE_INFRASTRUCTURE,
	WIRELESS_MODE_ADHOC
} WirelessMode;

struct _WifiConnectionPrivate {
	char* _network;
	double _signal;
	char* _last_used;
	char* _name;
	char* _ssid;
	char* _bssid;
	WirelessMode _mode;
	gboolean _autoconnect;
	gboolean _share_settings;
};


static gpointer wifi_connection_parent_class = NULL;

GType wifi_connection_get_type (void) G_GNUC_CONST;
GType wireless_mode_get_type (void) G_GNUC_CONST;
#define WIFI_CONNECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_WIFI_CONNECTION, WifiConnectionPrivate))
enum  {
	WIFI_CONNECTION_DUMMY_PROPERTY,
	WIFI_CONNECTION_NETWORK,
	WIFI_CONNECTION_SIGNAL,
	WIFI_CONNECTION_LAST_USED,
	WIFI_CONNECTION_NAME,
	WIFI_CONNECTION_SSID,
	WIFI_CONNECTION_BSSID,
	WIFI_CONNECTION_MODE,
	WIFI_CONNECTION_AUTOCONNECT,
	WIFI_CONNECTION_SHARE_SETTINGS
};
void wifi_connection_connect_ (WifiConnection* self, const char* key);
const char* wifi_connection_get_network (WifiConnection* self);
WifiConnection* wifi_connection_new (void);
WifiConnection* wifi_connection_construct (GType object_type);
void wifi_connection_set_network (WifiConnection* self, const char* value);
double wifi_connection_get_signal (WifiConnection* self);
void wifi_connection_set_signal (WifiConnection* self, double value);
const char* wifi_connection_get_last_used (WifiConnection* self);
void wifi_connection_set_last_used (WifiConnection* self, const char* value);
const char* wifi_connection_get_name (WifiConnection* self);
void wifi_connection_set_name (WifiConnection* self, const char* value);
const char* wifi_connection_get_ssid (WifiConnection* self);
void wifi_connection_set_ssid (WifiConnection* self, const char* value);
const char* wifi_connection_get_bssid (WifiConnection* self);
void wifi_connection_set_bssid (WifiConnection* self, const char* value);
WirelessMode wifi_connection_get_mode (WifiConnection* self);
void wifi_connection_set_mode (WifiConnection* self, WirelessMode value);
gboolean wifi_connection_get_autoconnect (WifiConnection* self);
void wifi_connection_set_autoconnect (WifiConnection* self, gboolean value);
gboolean wifi_connection_get_share_settings (WifiConnection* self);
void wifi_connection_set_share_settings (WifiConnection* self, gboolean value);
static void wifi_connection_finalize (GObject* obj);
static void wifi_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void wifi_connection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType device_get_type (void) G_GNUC_CONST;
WifiConnection** get_remembered_wireless_connections (Device* device, int* result_length1);



static const char* string_to_string (const char* self) {
	const char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


void wifi_connection_connect_ (WifiConnection* self, const char* key) {
	char* network;
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	network = g_strdup (self->priv->_network);
	fprintf (stdout, "%s", _tmp0_ = g_strconcat ("Connecting to ", string_to_string (network), "\n", NULL));
	_g_free0 (_tmp0_);
	_g_free0 (network);
}


WifiConnection* wifi_connection_construct (GType object_type) {
	WifiConnection * self;
	self = (WifiConnection*) g_object_new (object_type, NULL);
	return self;
}


WifiConnection* wifi_connection_new (void) {
	return wifi_connection_construct (TYPE_WIFI_CONNECTION);
}


const char* wifi_connection_get_network (WifiConnection* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_network;
	return result;
}


void wifi_connection_set_network (WifiConnection* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_network = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_network), _tmp0_);
	g_object_notify ((GObject *) self, "network");
}


double wifi_connection_get_signal (WifiConnection* self) {
	double result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_signal;
	return result;
}


void wifi_connection_set_signal (WifiConnection* self, double value) {
	g_return_if_fail (self != NULL);
	self->priv->_signal = value;
	g_object_notify ((GObject *) self, "signal");
}


const char* wifi_connection_get_last_used (WifiConnection* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_last_used;
	return result;
}


void wifi_connection_set_last_used (WifiConnection* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_last_used = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_last_used), _tmp0_);
	g_object_notify ((GObject *) self, "last-used");
}


const char* wifi_connection_get_name (WifiConnection* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_name;
	return result;
}


void wifi_connection_set_name (WifiConnection* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_name = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_name), _tmp0_);
	g_object_notify ((GObject *) self, "name");
}


const char* wifi_connection_get_ssid (WifiConnection* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_ssid;
	return result;
}


void wifi_connection_set_ssid (WifiConnection* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_ssid = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_ssid), _tmp0_);
	g_object_notify ((GObject *) self, "ssid");
}


const char* wifi_connection_get_bssid (WifiConnection* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_bssid;
	return result;
}


void wifi_connection_set_bssid (WifiConnection* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_bssid = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_bssid), _tmp0_);
	g_object_notify ((GObject *) self, "bssid");
}


WirelessMode wifi_connection_get_mode (WifiConnection* self) {
	WirelessMode result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_mode;
	return result;
}


void wifi_connection_set_mode (WifiConnection* self, WirelessMode value) {
	g_return_if_fail (self != NULL);
	self->priv->_mode = value;
	g_object_notify ((GObject *) self, "mode");
}


gboolean wifi_connection_get_autoconnect (WifiConnection* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_autoconnect;
	return result;
}


void wifi_connection_set_autoconnect (WifiConnection* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_autoconnect = value;
	g_object_notify ((GObject *) self, "autoconnect");
}


gboolean wifi_connection_get_share_settings (WifiConnection* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_share_settings;
	return result;
}


void wifi_connection_set_share_settings (WifiConnection* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_share_settings = value;
	g_object_notify ((GObject *) self, "share-settings");
}


static void wifi_connection_class_init (WifiConnectionClass * klass) {
	wifi_connection_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (WifiConnectionPrivate));
	G_OBJECT_CLASS (klass)->get_property = wifi_connection_get_property;
	G_OBJECT_CLASS (klass)->set_property = wifi_connection_set_property;
	G_OBJECT_CLASS (klass)->finalize = wifi_connection_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIFI_CONNECTION_NETWORK, g_param_spec_string ("network", "network", "network", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIFI_CONNECTION_SIGNAL, g_param_spec_double ("signal", "signal", "signal", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIFI_CONNECTION_LAST_USED, g_param_spec_string ("last-used", "last-used", "last-used", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIFI_CONNECTION_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIFI_CONNECTION_SSID, g_param_spec_string ("ssid", "ssid", "ssid", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIFI_CONNECTION_BSSID, g_param_spec_string ("bssid", "bssid", "bssid", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIFI_CONNECTION_MODE, g_param_spec_enum ("mode", "mode", "mode", TYPE_WIRELESS_MODE, WIRELESS_MODE_INFRASTRUCTURE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIFI_CONNECTION_AUTOCONNECT, g_param_spec_boolean ("autoconnect", "autoconnect", "autoconnect", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIFI_CONNECTION_SHARE_SETTINGS, g_param_spec_boolean ("share-settings", "share-settings", "share-settings", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void wifi_connection_instance_init (WifiConnection * self) {
	self->priv = WIFI_CONNECTION_GET_PRIVATE (self);
	self->priv->_mode = WIRELESS_MODE_INFRASTRUCTURE;
	self->priv->_autoconnect = FALSE;
	self->priv->_share_settings = FALSE;
}


static void wifi_connection_finalize (GObject* obj) {
	WifiConnection * self;
	self = WIFI_CONNECTION (obj);
	_g_free0 (self->priv->_network);
	_g_free0 (self->priv->_last_used);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_ssid);
	_g_free0 (self->priv->_bssid);
	G_OBJECT_CLASS (wifi_connection_parent_class)->finalize (obj);
}


GType wifi_connection_get_type (void) {
	static volatile gsize wifi_connection_type_id__volatile = 0;
	if (g_once_init_enter (&wifi_connection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (WifiConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wifi_connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WifiConnection), 0, (GInstanceInitFunc) wifi_connection_instance_init, NULL };
		GType wifi_connection_type_id;
		wifi_connection_type_id = g_type_register_static (G_TYPE_OBJECT, "WifiConnection", &g_define_type_info, 0);
		g_once_init_leave (&wifi_connection_type_id__volatile, wifi_connection_type_id);
	}
	return wifi_connection_type_id__volatile;
}


static void wifi_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	WifiConnection * self;
	self = WIFI_CONNECTION (object);
	switch (property_id) {
		case WIFI_CONNECTION_NETWORK:
		g_value_set_string (value, wifi_connection_get_network (self));
		break;
		case WIFI_CONNECTION_SIGNAL:
		g_value_set_double (value, wifi_connection_get_signal (self));
		break;
		case WIFI_CONNECTION_LAST_USED:
		g_value_set_string (value, wifi_connection_get_last_used (self));
		break;
		case WIFI_CONNECTION_NAME:
		g_value_set_string (value, wifi_connection_get_name (self));
		break;
		case WIFI_CONNECTION_SSID:
		g_value_set_string (value, wifi_connection_get_ssid (self));
		break;
		case WIFI_CONNECTION_BSSID:
		g_value_set_string (value, wifi_connection_get_bssid (self));
		break;
		case WIFI_CONNECTION_MODE:
		g_value_set_enum (value, wifi_connection_get_mode (self));
		break;
		case WIFI_CONNECTION_AUTOCONNECT:
		g_value_set_boolean (value, wifi_connection_get_autoconnect (self));
		break;
		case WIFI_CONNECTION_SHARE_SETTINGS:
		g_value_set_boolean (value, wifi_connection_get_share_settings (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void wifi_connection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	WifiConnection * self;
	self = WIFI_CONNECTION (object);
	switch (property_id) {
		case WIFI_CONNECTION_NETWORK:
		wifi_connection_set_network (self, g_value_get_string (value));
		break;
		case WIFI_CONNECTION_SIGNAL:
		wifi_connection_set_signal (self, g_value_get_double (value));
		break;
		case WIFI_CONNECTION_LAST_USED:
		wifi_connection_set_last_used (self, g_value_get_string (value));
		break;
		case WIFI_CONNECTION_NAME:
		wifi_connection_set_name (self, g_value_get_string (value));
		break;
		case WIFI_CONNECTION_SSID:
		wifi_connection_set_ssid (self, g_value_get_string (value));
		break;
		case WIFI_CONNECTION_BSSID:
		wifi_connection_set_bssid (self, g_value_get_string (value));
		break;
		case WIFI_CONNECTION_MODE:
		wifi_connection_set_mode (self, g_value_get_enum (value));
		break;
		case WIFI_CONNECTION_AUTOCONNECT:
		wifi_connection_set_autoconnect (self, g_value_get_boolean (value));
		break;
		case WIFI_CONNECTION_SHARE_SETTINGS:
		wifi_connection_set_share_settings (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


WifiConnection** get_remembered_wireless_connections (Device* device, int* result_length1) {
	WifiConnection** result = NULL;
	WifiConnection* connection1;
	WifiConnection* connection2;
	WifiConnection* connection3;
	WifiConnection** _tmp0_ = NULL;
	WifiConnection** _tmp1_;
	g_return_val_if_fail (device != NULL, NULL);
	connection1 = wifi_connection_new ();
	wifi_connection_set_name (connection1, "Downstairs Router (above the biscuit tin)");
	wifi_connection_set_signal (connection1, (double) 0.75);
	wifi_connection_set_last_used (connection1, "1/1/1");
	wifi_connection_set_ssid (connection1, "BTHomeHub-193209");
	wifi_connection_set_bssid (connection1, "BBTHomeHub-193209");
	wifi_connection_set_mode (connection1, WIRELESS_MODE_INFRASTRUCTURE);
	wifi_connection_set_autoconnect (connection1, TRUE);
	wifi_connection_set_share_settings (connection1, TRUE);
	connection2 = wifi_connection_new ();
	wifi_connection_set_name (connection2, "SKY-001");
	wifi_connection_set_signal (connection2, (double) 0.55);
	wifi_connection_set_last_used (connection2, "1/1/1");
	wifi_connection_set_ssid (connection2, "SKY-001");
	connection3 = wifi_connection_new ();
	wifi_connection_set_name (connection3, "Starbucks OpenAccess");
	wifi_connection_set_signal (connection3, (double) 0.2);
	wifi_connection_set_last_used (connection3, "1/1/1");
	wifi_connection_set_ssid (connection3, "Starbucks-1223Open");
	result = (_tmp1_ = (_tmp0_ = g_new0 (WifiConnection*, 3 + 1), _tmp0_[0] = _g_object_ref0 (connection1), _tmp0_[1] = _g_object_ref0 (connection2), _tmp0_[2] = _g_object_ref0 (connection3), _tmp0_), *result_length1 = 3, _tmp1_);
	_g_object_unref0 (connection3);
	_g_object_unref0 (connection2);
	_g_object_unref0 (connection1);
	return result;
	_g_object_unref0 (connection3);
	_g_object_unref0 (connection2);
	_g_object_unref0 (connection1);
}




