/*
 * indicator-network - user interface for connman
 * Copyright 2010-2011 Canonical Ltd.
 *
 * Authors:
 * Andrew Higginson
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 3, as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

public class WifiConnection : GLib.Object {
    public string network { get; set; }
    public double signal { get; set; }
    public string last_used { get; set; }
    public string name { get; set; }
    public string ssid { get; set; }
    public string? bssid { get; set; }
    public WirelessMode mode { get; set; default = WirelessMode.INFRASTRUCTURE; }
    public bool autoconnect { get; set; default = false; }
    public bool share_settings { get; set; default = false; }

    public void connect_(string key) {
        var network = this.network;
        stdout.printf(@"Connecting to $network\n");
    }
}

public WifiConnection[] get_remembered_wireless_connections(Device device) {
    // Dummy Connections (temporary)
    var connection1 = new WifiConnection();
    connection1.name = "Downstairs Router (above the biscuit tin)";
    connection1.signal = (double) 0.75;
    connection1.last_used = "1/1/1";
    connection1.ssid = "BTHomeHub-193209";
    connection1.bssid = "BBTHomeHub-193209";
    connection1.mode = WirelessMode.INFRASTRUCTURE;
    connection1.autoconnect = true;
    connection1.share_settings = true;
    
    var connection2 = new WifiConnection();
    connection2.name = "SKY-001";
    connection2.signal = (double) 0.55;
    connection2.last_used = "1/1/1";
    connection2.ssid = "SKY-001";
    
    var connection3 = new WifiConnection();
    connection3.name = "Starbucks OpenAccess";
    connection3.signal = (double) 0.2;
    connection3.last_used = "1/1/1";
    connection3.ssid = "Starbucks-1223Open";
    //
    return {connection1, connection2, connection3};
}
