/* device.c generated by valac 0.10.0, the Vala compiler
 * generated from device.vala, do not modify */

/*
 * indicator-network - user interface for connman
 * Copyright 2010-2011 Canonical Ltd.
 *
 * Authors:
 * Andrew Higginson
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 3, as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>


#define TYPE_DEVICE (device_get_type ())
#define DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEVICE, Device))
#define DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEVICE, DeviceClass))
#define IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEVICE))
#define IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEVICE))
#define DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEVICE, DeviceClass))

typedef struct _Device Device;
typedef struct _DeviceClass DeviceClass;
typedef struct _DevicePrivate DevicePrivate;

#define TYPE_DEVICE_TYPE (device_type_get_type ())

#define TYPE_DEVICE_STATE (device_state_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Device {
	GObject parent_instance;
	DevicePrivate * priv;
};

struct _DeviceClass {
	GObjectClass parent_class;
};

typedef enum  {
	DEVICE_TYPE_WIRED,
	DEVICE_TYPE_WIRELESS,
	DEVICE_TYPE_BLUETOOTH,
	DEVICE_TYPE_MOBILE,
	DEVICE_TYPE_GENERIC
} DeviceType;

typedef enum  {
	DEVICE_STATE_OFF,
	DEVICE_STATE_OFFLINE,
	DEVICE_STATE_CONNECTED,
	DEVICE_STATE_ONLINE
} DeviceState;

struct _DevicePrivate {
	DeviceType _type_;
	DeviceState _state;
};


static gpointer device_parent_class = NULL;

GType device_get_type (void) G_GNUC_CONST;
GType device_type_get_type (void) G_GNUC_CONST;
GType device_state_get_type (void) G_GNUC_CONST;
#define DEVICE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DEVICE, DevicePrivate))
enum  {
	DEVICE_DUMMY_PROPERTY,
	DEVICE_TYPE_,
	DEVICE_STATE
};
Device* device_new (void);
Device* device_construct (GType object_type);
DeviceType device_get_type_ (Device* self);
void device_set_type_ (Device* self, DeviceType value);
DeviceState device_get_state (Device* self);
void device_set_state (Device* self, DeviceState value);
static void device_finalize (GObject* obj);
static void device_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void device_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
Device** get_wired_devices (int* result_length1);
Device** get_wireless_devices (int* result_length1);
Device** get_mobile_devices (int* result_length1);
Device** get_bluetooth_devices (int* result_length1);



Device* device_construct (GType object_type) {
	Device * self;
	self = (Device*) g_object_new (object_type, NULL);
	return self;
}


Device* device_new (void) {
	return device_construct (TYPE_DEVICE);
}


DeviceType device_get_type_ (Device* self) {
	DeviceType result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_type_;
	return result;
}


void device_set_type_ (Device* self, DeviceType value) {
	g_return_if_fail (self != NULL);
	self->priv->_type_ = value;
	g_object_notify ((GObject *) self, "type-");
}


DeviceState device_get_state (Device* self) {
	DeviceState result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_state;
	return result;
}


void device_set_state (Device* self, DeviceState value) {
	g_return_if_fail (self != NULL);
	self->priv->_state = value;
	g_object_notify ((GObject *) self, "state");
}


static void device_class_init (DeviceClass * klass) {
	device_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DevicePrivate));
	G_OBJECT_CLASS (klass)->get_property = device_get_property;
	G_OBJECT_CLASS (klass)->set_property = device_set_property;
	G_OBJECT_CLASS (klass)->finalize = device_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_TYPE_, g_param_spec_enum ("type-", "type-", "type-", TYPE_DEVICE_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_STATE, g_param_spec_enum ("state", "state", "state", TYPE_DEVICE_STATE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void device_instance_init (Device * self) {
	self->priv = DEVICE_GET_PRIVATE (self);
}


static void device_finalize (GObject* obj) {
	Device * self;
	self = DEVICE (obj);
	G_OBJECT_CLASS (device_parent_class)->finalize (obj);
}


GType device_get_type (void) {
	static volatile gsize device_type_id__volatile = 0;
	if (g_once_init_enter (&device_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Device), 0, (GInstanceInitFunc) device_instance_init, NULL };
		GType device_type_id;
		device_type_id = g_type_register_static (G_TYPE_OBJECT, "Device", &g_define_type_info, 0);
		g_once_init_leave (&device_type_id__volatile, device_type_id);
	}
	return device_type_id__volatile;
}


static void device_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Device * self;
	self = DEVICE (object);
	switch (property_id) {
		case DEVICE_TYPE_:
		g_value_set_enum (value, device_get_type_ (self));
		break;
		case DEVICE_STATE:
		g_value_set_enum (value, device_get_state (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void device_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Device * self;
	self = DEVICE (object);
	switch (property_id) {
		case DEVICE_TYPE_:
		device_set_type_ (self, g_value_get_enum (value));
		break;
		case DEVICE_STATE:
		device_set_state (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


Device** get_wired_devices (int* result_length1) {
	Device** result = NULL;
	Device* device1;
	Device** _tmp0_ = NULL;
	Device** _tmp1_;
	device1 = device_new ();
	device_set_type_ (device1, DEVICE_TYPE_WIRED);
	device_set_state (device1, DEVICE_STATE_OFFLINE);
	result = (_tmp1_ = (_tmp0_ = g_new0 (Device*, 1 + 1), _tmp0_[0] = _g_object_ref0 (device1), _tmp0_), *result_length1 = 1, _tmp1_);
	_g_object_unref0 (device1);
	return result;
	_g_object_unref0 (device1);
}


Device** get_wireless_devices (int* result_length1) {
	Device** result = NULL;
	Device* device1;
	Device* device2;
	Device** _tmp0_ = NULL;
	Device** _tmp1_;
	device1 = device_new ();
	device_set_type_ (device1, DEVICE_TYPE_WIRELESS);
	device_set_state (device1, DEVICE_STATE_ONLINE);
	device2 = device_new ();
	device_set_type_ (device2, DEVICE_TYPE_WIRELESS);
	device_set_state (device2, DEVICE_STATE_OFF);
	result = (_tmp1_ = (_tmp0_ = g_new0 (Device*, 2 + 1), _tmp0_[0] = _g_object_ref0 (device1), _tmp0_[1] = _g_object_ref0 (device2), _tmp0_), *result_length1 = 2, _tmp1_);
	_g_object_unref0 (device2);
	_g_object_unref0 (device1);
	return result;
	_g_object_unref0 (device2);
	_g_object_unref0 (device1);
}


Device** get_mobile_devices (int* result_length1) {
	Device** result = NULL;
	Device* device3;
	Device** _tmp0_ = NULL;
	Device** _tmp1_;
	device3 = device_new ();
	device_set_type_ (device3, DEVICE_TYPE_MOBILE);
	device_set_state (device3, DEVICE_STATE_CONNECTED);
	result = (_tmp1_ = (_tmp0_ = g_new0 (Device*, 1 + 1), _tmp0_[0] = _g_object_ref0 (device3), _tmp0_), *result_length1 = 1, _tmp1_);
	_g_object_unref0 (device3);
	return result;
	_g_object_unref0 (device3);
}


Device** get_bluetooth_devices (int* result_length1) {
	Device** result = NULL;
	Device* device4;
	Device** _tmp0_ = NULL;
	Device** _tmp1_;
	device4 = device_new ();
	device_set_type_ (device4, DEVICE_TYPE_BLUETOOTH);
	device_set_state (device4, DEVICE_STATE_OFF);
	result = (_tmp1_ = (_tmp0_ = g_new0 (Device*, 1 + 1), _tmp0_[0] = _g_object_ref0 (device4), _tmp0_), *result_length1 = 1, _tmp1_);
	_g_object_unref0 (device4);
	return result;
	_g_object_unref0 (device4);
}




