/* enums.c generated by valac 0.10.0, the Vala compiler
 * generated from enums.vala, do not modify */

/*
 * indicator-network - user interface for connman
 * Copyright 2010-2011 Canonical Ltd.
 *
 * Authors:
 * Andrew Higginson
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 3, as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_DEVICE_TYPE (device_type_get_type ())

#define TYPE_DEVICE_STATE (device_state_get_type ())

#define TYPE_WIRELESS_MODE (wireless_mode_get_type ())

typedef enum  {
	DEVICE_TYPE_WIRED,
	DEVICE_TYPE_WIRELESS,
	DEVICE_TYPE_BLUETOOTH,
	DEVICE_TYPE_MOBILE,
	DEVICE_TYPE_GENERIC
} DeviceType;

typedef enum  {
	DEVICE_STATE_OFF,
	DEVICE_STATE_OFFLINE,
	DEVICE_STATE_CONNECTED,
	DEVICE_STATE_ONLINE
} DeviceState;

typedef enum  {
	WIRELESS_MODE_INFRASTRUCTURE,
	WIRELESS_MODE_ADHOC
} WirelessMode;



GType device_type_get_type (void) G_GNUC_CONST;
char* device_type_get_name (DeviceType self);
char* device_type_get_lname (DeviceType self);
char* device_type_get_icon_name (DeviceType self);
GType device_state_get_type (void) G_GNUC_CONST;
char* device_state_get_name (DeviceState self);
GType wireless_mode_get_type (void) G_GNUC_CONST;
char* wireless_mode_get_name (WirelessMode self);



char* device_type_get_name (DeviceType self) {
	char* result = NULL;
	switch (self) {
		case DEVICE_TYPE_WIRED:
		{
			result = g_strdup ("Wired");
			return result;
		}
		case DEVICE_TYPE_WIRELESS:
		{
			result = g_strdup ("Wireless");
			return result;
		}
		case DEVICE_TYPE_BLUETOOTH:
		{
			result = g_strdup ("Bluetooth");
			return result;
		}
		case DEVICE_TYPE_MOBILE:
		{
			result = g_strdup ("Mobile Broadband");
			return result;
		}
		case DEVICE_TYPE_GENERIC:
		{
			result = g_strdup ("Wired");
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}


char* device_type_get_lname (DeviceType self) {
	char* result = NULL;
	switch (self) {
		case DEVICE_TYPE_WIRED:
		{
			result = g_strdup ("wired");
			return result;
		}
		case DEVICE_TYPE_WIRELESS:
		{
			result = g_strdup ("wireless");
			return result;
		}
		case DEVICE_TYPE_BLUETOOTH:
		{
			result = g_strdup ("bluetooth");
			return result;
		}
		case DEVICE_TYPE_MOBILE:
		{
			result = g_strdup ("mobile");
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}


char* device_type_get_icon_name (DeviceType self) {
	char* result = NULL;
	switch (self) {
		case DEVICE_TYPE_WIRED:
		{
			result = g_strdup ("network-wired");
			return result;
		}
		case DEVICE_TYPE_WIRELESS:
		{
			result = g_strdup ("network-wireless");
			return result;
		}
		case DEVICE_TYPE_BLUETOOTH:
		{
			result = g_strdup ("bluetooth-active");
			return result;
		}
		case DEVICE_TYPE_MOBILE:
		{
			result = g_strdup ("gsm-3g-high");
			return result;
		}
		case DEVICE_TYPE_GENERIC:
		{
			result = g_strdup ("network-wired");
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}


GType device_type_get_type (void) {
	static volatile gsize device_type_type_id__volatile = 0;
	if (g_once_init_enter (&device_type_type_id__volatile)) {
		static const GEnumValue values[] = {{DEVICE_TYPE_WIRED, "DEVICE_TYPE_WIRED", "wired"}, {DEVICE_TYPE_WIRELESS, "DEVICE_TYPE_WIRELESS", "wireless"}, {DEVICE_TYPE_BLUETOOTH, "DEVICE_TYPE_BLUETOOTH", "bluetooth"}, {DEVICE_TYPE_MOBILE, "DEVICE_TYPE_MOBILE", "mobile"}, {DEVICE_TYPE_GENERIC, "DEVICE_TYPE_GENERIC", "generic"}, {0, NULL, NULL}};
		GType device_type_type_id;
		device_type_type_id = g_enum_register_static ("DeviceType", values);
		g_once_init_leave (&device_type_type_id__volatile, device_type_type_id);
	}
	return device_type_type_id__volatile;
}


char* device_state_get_name (DeviceState self) {
	char* result = NULL;
	switch (self) {
		case DEVICE_STATE_OFF:
		{
			result = g_strdup ("Off");
			return result;
		}
		case DEVICE_STATE_OFFLINE:
		{
			result = g_strdup ("Offline");
			return result;
		}
		case DEVICE_STATE_CONNECTED:
		{
			result = g_strdup ("Connected");
			return result;
		}
		case DEVICE_STATE_ONLINE:
		{
			result = g_strdup ("Online");
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}


GType device_state_get_type (void) {
	static volatile gsize device_state_type_id__volatile = 0;
	if (g_once_init_enter (&device_state_type_id__volatile)) {
		static const GEnumValue values[] = {{DEVICE_STATE_OFF, "DEVICE_STATE_OFF", "off"}, {DEVICE_STATE_OFFLINE, "DEVICE_STATE_OFFLINE", "offline"}, {DEVICE_STATE_CONNECTED, "DEVICE_STATE_CONNECTED", "connected"}, {DEVICE_STATE_ONLINE, "DEVICE_STATE_ONLINE", "online"}, {0, NULL, NULL}};
		GType device_state_type_id;
		device_state_type_id = g_enum_register_static ("DeviceState", values);
		g_once_init_leave (&device_state_type_id__volatile, device_state_type_id);
	}
	return device_state_type_id__volatile;
}


char* wireless_mode_get_name (WirelessMode self) {
	char* result = NULL;
	switch (self) {
		case WIRELESS_MODE_INFRASTRUCTURE:
		{
			result = g_strdup ("Infrastructure");
			return result;
		}
		case WIRELESS_MODE_ADHOC:
		{
			result = g_strdup ("Ad-hoc");
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}


GType wireless_mode_get_type (void) {
	static volatile gsize wireless_mode_type_id__volatile = 0;
	if (g_once_init_enter (&wireless_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{WIRELESS_MODE_INFRASTRUCTURE, "WIRELESS_MODE_INFRASTRUCTURE", "infrastructure"}, {WIRELESS_MODE_ADHOC, "WIRELESS_MODE_ADHOC", "adhoc"}, {0, NULL, NULL}};
		GType wireless_mode_type_id;
		wireless_mode_type_id = g_enum_register_static ("WirelessMode", values);
		g_once_init_leave (&wireless_mode_type_id__volatile, wireless_mode_type_id);
	}
	return wireless_mode_type_id__volatile;
}




