/* utils.c generated by valac 0.10.0, the Vala compiler
 * generated from utils.vala, do not modify */

/*
 * indicator-network - user interface for connman
 * Copyright 2010-2011 Canonical Ltd.
 *
 * Authors:
 * Andrew Higginson
 * Gordon Allott <gord.allott@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 3, as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>


#define TYPE_LOGGER (logger_get_type ())
#define LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGGER, Logger))
#define LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOGGER, LoggerClass))
#define IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGGER))
#define IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOGGER))
#define LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOGGER, LoggerClass))

typedef struct _Logger Logger;
typedef struct _LoggerClass LoggerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))


extern Logger* logger;

void utils_color_rgb_to_hsv (float r, float g, float b, float* hue, float* sat, float* val);
void utils_color_hsv_to_rgb (float hue, float sat, float val, float* r, float* g, float* b);
void utils_color_color_to_hls (GdkColor* color, float* hue, float* luminance, float* saturation);
void utils_color_color_from_hls (float hue, float luminance, float saturation, GdkColor* color);
void utils_color_shade (GdkColor* color, GdkColor* result);
GtkBuilder* utils_gui_new_builder (const char* path);
GType logger_get_type (void) G_GNUC_CONST;
void logger_debug (Logger* self, const char* text);



void utils_color_rgb_to_hsv (float r, float g, float b, float* hue, float* sat, float* val) {
	float min = 0.0F;
	float max;
	float delta;
	max = 0.0f;
	if (r > g) {
		float _tmp0_ = 0.0F;
		if (r > b) {
			_tmp0_ = r;
		} else {
			_tmp0_ = b;
		}
		max = _tmp0_;
	} else {
		float _tmp1_ = 0.0F;
		if (g > b) {
			_tmp1_ = g;
		} else {
			_tmp1_ = b;
		}
		max = _tmp1_;
	}
	if (r < g) {
		float _tmp2_ = 0.0F;
		if (r < b) {
			_tmp2_ = r;
		} else {
			_tmp2_ = b;
		}
		min = _tmp2_;
	} else {
		float _tmp3_ = 0.0F;
		if (g < b) {
			_tmp3_ = g;
		} else {
			_tmp3_ = b;
		}
		min = _tmp3_;
	}
	*val = max;
	delta = max - min;
	if (delta > 0.000001) {
		*sat = delta / max;
		*hue = 0.0f;
		if (r == max) {
			*hue = (g - b) / delta;
			if ((*hue) < 0.0f) {
				*hue = (*hue) + 6.0f;
			}
		} else {
			if (g == max) {
				*hue = 2.0f + ((b - r) / delta);
			} else {
				if (b == max) {
					*hue = 4.0f + ((r - g) / delta);
				}
			}
		}
		*hue = (*hue) / 6.0f;
	} else {
		*sat = 0.0f;
		*hue = 0.0f;
	}
}


void utils_color_hsv_to_rgb (float hue, float sat, float val, float* r, float* g, float* b) {
	gint i = 0;
	float f = 0.0F;
	float w = 0.0F;
	float q = 0.0F;
	float t = 0.0F;
	if (sat == 0.0) {
		*r = *g = *b = val;
	} else {
		if (hue == 1.0) {
			hue = 0.0f;
		}
		hue = hue * 6.0f;
		i = (gint) hue;
		f = hue - i;
		w = val * (1.0f - sat);
		q = val * (1.0f - (sat * f));
		t = val * (1.0f - (sat * (1.0f - f)));
		switch (i) {
			case 0:
			{
				*r = val;
				*g = t;
				*b = w;
				break;
			}
			case 1:
			{
				*r = q;
				*g = val;
				*b = w;
				break;
			}
			case 2:
			{
				*r = w;
				*g = val;
				*b = t;
				break;
			}
			case 3:
			{
				*r = w;
				*g = q;
				*b = val;
				break;
			}
			case 4:
			{
				*r = t;
				*g = w;
				*b = val;
				break;
			}
			case 5:
			{
				*r = val;
				*g = w;
				*b = q;
				break;
			}
		}
	}
}


void utils_color_color_to_hls (GdkColor* color, float* hue, float* luminance, float* saturation) {
	float red = 0.0F;
	float green = 0.0F;
	float blue = 0.0F;
	float h = 0.0F;
	float l = 0.0F;
	float v = 0.0F;
	red = (*color).red / 65535.0f;
	green = (*color).green / 65535.0f;
	blue = (*color).blue / 65535.0f;
	utils_color_rgb_to_hsv (red, green, blue, &h, &l, &v);
	*hue = h;
	*luminance = l;
	*saturation = v;
}


void utils_color_color_from_hls (float hue, float luminance, float saturation, GdkColor* color) {
	float red = 0.0F;
	float green = 0.0F;
	float blue = 0.0F;
	utils_color_hsv_to_rgb (hue, luminance, saturation, &red, &green, &blue);
	(*color).red = (guint16) floorf ((red * 65535.0f) + 0.5f);
	(*color).green = (guint16) floorf ((green * 65535.0f) + 0.5f);
	(*color).blue = (guint16) floorf ((blue * 65535.0f) + 0.5f);
}


void utils_color_shade (GdkColor* color, GdkColor* result) {
	float h = 0.0F;
	float l = 0.0F;
	float s = 0.0F;
	float factor = 0.0F;
	GdkColor new_color = {0};
	utils_color_color_to_hls (color, &h, &l, &s);
	if (l > 0.5) {
		factor = 0.6f;
	} else {
		factor = 1.4f;
	}
	l = l * factor;
	if (l > 1.0f) {
		l = 1.0f;
	} else {
		if (l < 0) {
			l = (float) 0;
		}
	}
	s = s * factor;
	if (s > 1.0f) {
		s = 1.0f;
	} else {
		if (s < 0) {
			s = (float) 0;
		}
	}
	utils_color_color_from_hls (h, l, s, &new_color);
	*result = new_color;
	return;
}


static const char* string_to_string (const char* self) {
	const char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


GtkBuilder* utils_gui_new_builder (const char* path) {
	GtkBuilder* result = NULL;
	GtkBuilder* builder;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	builder = gtk_builder_new ();
	{
		gtk_builder_add_from_file (builder, path, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp0_;
			logger_debug (logger, _tmp0_ = g_strconcat ("Can't find ", string_to_string (path), ".", NULL));
			_g_free0 (_tmp0_);
			_g_error_free0 (e);
		}
	}
	__finally1:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (builder);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	gtk_builder_set_translation_domain (builder, "indicator-network-settings");
	result = builder;
	return result;
}




