/* edit-connection.c generated by valac 0.10.0, the Vala compiler
 * generated from edit-connection.vala, do not modify */

/*
 * indicator-network - user interface for connman
 * Copyright 2010-2011 Canonical Ltd.
 *
 * Authors:
 * Andrew Higginson
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 3, as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>


#define TYPE_EDIT_CONNECTION_DIALOG (edit_connection_dialog_get_type ())
#define EDIT_CONNECTION_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EDIT_CONNECTION_DIALOG, EditConnectionDialog))
#define EDIT_CONNECTION_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EDIT_CONNECTION_DIALOG, EditConnectionDialogClass))
#define IS_EDIT_CONNECTION_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EDIT_CONNECTION_DIALOG))
#define IS_EDIT_CONNECTION_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EDIT_CONNECTION_DIALOG))
#define EDIT_CONNECTION_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EDIT_CONNECTION_DIALOG, EditConnectionDialogClass))

typedef struct _EditConnectionDialog EditConnectionDialog;
typedef struct _EditConnectionDialogClass EditConnectionDialogClass;
typedef struct _EditConnectionDialogPrivate EditConnectionDialogPrivate;

#define TYPE_WIFI_CONNECTION (wifi_connection_get_type ())
#define WIFI_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WIFI_CONNECTION, WifiConnection))
#define WIFI_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WIFI_CONNECTION, WifiConnectionClass))
#define IS_WIFI_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WIFI_CONNECTION))
#define IS_WIFI_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WIFI_CONNECTION))
#define WIFI_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WIFI_CONNECTION, WifiConnectionClass))

typedef struct _WifiConnection WifiConnection;
typedef struct _WifiConnectionClass WifiConnectionClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_WIRELESS_MODE (wireless_mode_get_type ())
typedef struct _Block3Data Block3Data;

struct _EditConnectionDialog {
	GObject parent_instance;
	EditConnectionDialogPrivate * priv;
};

struct _EditConnectionDialogClass {
	GObjectClass parent_class;
};

struct _EditConnectionDialogPrivate {
	WifiConnection* connection;
	GtkBuilder* builder;
	GtkWindow* dialog;
	GtkTable* table_main;
	GtkButton* button_save;
	GtkButton* button_cancel;
	GtkEntry* entry_name;
	GtkEntry* entry_ssid;
	GtkEntry* entry_bssid;
	GtkComboBox* combobox_mode;
	GtkCheckButton* checkbutton_autoconnect;
	GtkCheckButton* checkbutton_share_settings;
	char** hint_labels;
	gint hint_labels_length1;
	gint _hint_labels_size_;
};

typedef enum  {
	WIRELESS_MODE_INFRASTRUCTURE,
	WIRELESS_MODE_ADHOC
} WirelessMode;

struct _Block3Data {
	int _ref_count_;
	EditConnectionDialog * self;
	GtkLabel* hint_label_widget;
};


static gpointer edit_connection_dialog_parent_class = NULL;

GType edit_connection_dialog_get_type (void) G_GNUC_CONST;
GType wifi_connection_get_type (void) G_GNUC_CONST;
#define EDIT_CONNECTION_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_EDIT_CONNECTION_DIALOG, EditConnectionDialogPrivate))
enum  {
	EDIT_CONNECTION_DIALOG_DUMMY_PROPERTY
};
EditConnectionDialog* edit_connection_dialog_new (WifiConnection* connection, const char* datadir);
EditConnectionDialog* edit_connection_dialog_construct (GType object_type, WifiConnection* connection, const char* datadir);
GtkBuilder* utils_gui_new_builder (const char* path);
static void edit_connection_dialog_get_widgets (EditConnectionDialog* self);
static void edit_connection_dialog_create_extra_widgets (EditConnectionDialog* self);
static void edit_connection_dialog_connect_signals (EditConnectionDialog* self);
static void edit_connection_dialog_update_widget_values (EditConnectionDialog* self);
GType wireless_mode_get_type (void) G_GNUC_CONST;
char* wireless_mode_get_name (WirelessMode self);
static void _lambda2_ (Block3Data* _data3_);
void utils_color_shade (GdkColor* color, GdkColor* result);
static void __lambda2__gtk_widget_realize (GtkWidget* _sender, gpointer self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (Block3Data* _data3_);
static void edit_connection_dialog_on_button_save_clicked (EditConnectionDialog* self);
static void _edit_connection_dialog_on_button_save_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void edit_connection_dialog_on_button_cancel_clicked (EditConnectionDialog* self);
static void _edit_connection_dialog_on_button_cancel_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
const char* wifi_connection_get_name (WifiConnection* self);
const char* wifi_connection_get_ssid (WifiConnection* self);
const char* wifi_connection_get_bssid (WifiConnection* self);
WirelessMode wifi_connection_get_mode (WifiConnection* self);
gboolean wifi_connection_get_autoconnect (WifiConnection* self);
gboolean wifi_connection_get_share_settings (WifiConnection* self);
static void edit_connection_dialog_save_widget_values (EditConnectionDialog* self);
void wifi_connection_set_name (WifiConnection* self, const char* value);
void wifi_connection_set_ssid (WifiConnection* self, const char* value);
void wifi_connection_set_bssid (WifiConnection* self, const char* value);
void wifi_connection_set_mode (WifiConnection* self, WirelessMode value);
void wifi_connection_set_autoconnect (WifiConnection* self, gboolean value);
void wifi_connection_set_share_settings (WifiConnection* self, gboolean value);
gint edit_connection_dialog_run (EditConnectionDialog* self);
static void edit_connection_dialog_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static int _vala_strcmp0 (const char * str1, const char * str2);



static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


EditConnectionDialog* edit_connection_dialog_construct (GType object_type, WifiConnection* connection, const char* datadir) {
	EditConnectionDialog * self;
	WifiConnection* _tmp0_;
	char* _tmp1_;
	GtkBuilder* _tmp2_;
	g_return_val_if_fail (connection != NULL, NULL);
	g_return_val_if_fail (datadir != NULL, NULL);
	self = (EditConnectionDialog*) g_object_new (object_type, NULL);
	self->priv->connection = (_tmp0_ = _g_object_ref0 (connection), _g_object_unref0 (self->priv->connection), _tmp0_);
	self->priv->builder = (_tmp2_ = utils_gui_new_builder (_tmp1_ = g_strconcat (datadir, "ui/edit_connection_dialog.ui", NULL)), _g_object_unref0 (self->priv->builder), _tmp2_);
	_g_free0 (_tmp1_);
	edit_connection_dialog_get_widgets (self);
	edit_connection_dialog_create_extra_widgets (self);
	edit_connection_dialog_connect_signals (self);
	edit_connection_dialog_update_widget_values (self);
	return self;
}


EditConnectionDialog* edit_connection_dialog_new (WifiConnection* connection, const char* datadir) {
	return edit_connection_dialog_construct (TYPE_EDIT_CONNECTION_DIALOG, connection, datadir);
}


static void _lambda2_ (Block3Data* _data3_) {
	EditConnectionDialog * self;
	GtkStateType state;
	GdkColor color;
	GdkColor _tmp0_ = {0};
	GdkColor new_color;
	self = _data3_->self;
	state = gtk_widget_get_state ((GtkWidget*) _data3_->hint_label_widget);
	color = gtk_widget_get_style ((GtkWidget*) _data3_->hint_label_widget)->fg[state];
	new_color = (utils_color_shade (&color, &_tmp0_), _tmp0_);
	gtk_widget_modify_fg ((GtkWidget*) _data3_->hint_label_widget, state, &new_color);
}


static void __lambda2__gtk_widget_realize (GtkWidget* _sender, gpointer self) {
	_lambda2_ (self);
}


static Block3Data* block3_data_ref (Block3Data* _data3_) {
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}


static void block3_data_unref (Block3Data* _data3_) {
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		_g_object_unref0 (_data3_->self);
		_g_object_unref0 (_data3_->hint_label_widget);
		g_slice_free (Block3Data, _data3_);
	}
}


static void edit_connection_dialog_create_extra_widgets (EditConnectionDialog* self) {
	GtkComboBox* _tmp0_;
	gint wireless_modes_length1;
	gint _wireless_modes_size_;
	WirelessMode* _tmp2_;
	WirelessMode* _tmp1_ = NULL;
	WirelessMode* wireless_modes;
	g_return_if_fail (self != NULL);
	self->priv->combobox_mode = (_tmp0_ = g_object_ref_sink ((GtkComboBox*) gtk_combo_box_new_text ()), _g_object_unref0 (self->priv->combobox_mode), _tmp0_);
	wireless_modes = (_tmp2_ = (_tmp1_ = g_new0 (WirelessMode, 2), _tmp1_[0] = WIRELESS_MODE_INFRASTRUCTURE, _tmp1_[1] = WIRELESS_MODE_ADHOC, _tmp1_), wireless_modes_length1 = 2, _wireless_modes_size_ = wireless_modes_length1, _tmp2_);
	{
		WirelessMode* mode_collection;
		int mode_collection_length1;
		int mode_it;
		mode_collection = wireless_modes;
		mode_collection_length1 = wireless_modes_length1;
		for (mode_it = 0; mode_it < wireless_modes_length1; mode_it = mode_it + 1) {
			WirelessMode mode;
			mode = mode_collection[mode_it];
			{
				char* _tmp3_;
				gtk_combo_box_append_text (self->priv->combobox_mode, _tmp3_ = wireless_mode_get_name (mode));
				_g_free0 (_tmp3_);
			}
		}
	}
	gtk_table_attach (self->priv->table_main, (GtkWidget*) self->priv->combobox_mode, (guint) 1, (guint) 2, (guint) 6, (guint) 7, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
	{
		char** hint_label_collection;
		int hint_label_collection_length1;
		int hint_label_it;
		hint_label_collection = self->priv->hint_labels;
		hint_label_collection_length1 = self->priv->hint_labels_length1;
		for (hint_label_it = 0; hint_label_it < self->priv->hint_labels_length1; hint_label_it = hint_label_it + 1) {
			char* hint_label;
			hint_label = g_strdup (hint_label_collection[hint_label_it]);
			{
				Block3Data* _data3_;
				GObject* _tmp4_;
				_data3_ = g_slice_new0 (Block3Data);
				_data3_->_ref_count_ = 1;
				_data3_->self = g_object_ref (self);
				_data3_->hint_label_widget = _g_object_ref0 ((_tmp4_ = gtk_builder_get_object (self->priv->builder, hint_label), GTK_IS_LABEL (_tmp4_) ? ((GtkLabel*) _tmp4_) : NULL));
				g_signal_connect_data ((GtkWidget*) _data3_->hint_label_widget, "realize", (GCallback) __lambda2__gtk_widget_realize, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
				_g_free0 (hint_label);
				block3_data_unref (_data3_);
			}
		}
	}
	wireless_modes = (g_free (wireless_modes), NULL);
}


static void edit_connection_dialog_get_widgets (EditConnectionDialog* self) {
	GObject* _tmp0_;
	GtkWindow* _tmp1_;
	GObject* _tmp2_;
	GtkTable* _tmp3_;
	GObject* _tmp4_;
	GtkButton* _tmp5_;
	GObject* _tmp6_;
	GtkButton* _tmp7_;
	GObject* _tmp8_;
	GtkEntry* _tmp9_;
	GObject* _tmp10_;
	GtkEntry* _tmp11_;
	GObject* _tmp12_;
	GtkEntry* _tmp13_;
	GObject* _tmp14_;
	GtkCheckButton* _tmp15_;
	GObject* _tmp16_;
	GtkCheckButton* _tmp17_;
	g_return_if_fail (self != NULL);
	self->priv->dialog = (_tmp1_ = _g_object_ref0 ((_tmp0_ = gtk_builder_get_object (self->priv->builder, "window_main"), GTK_IS_WINDOW (_tmp0_) ? ((GtkWindow*) _tmp0_) : NULL)), _g_object_unref0 (self->priv->dialog), _tmp1_);
	self->priv->table_main = (_tmp3_ = _g_object_ref0 ((_tmp2_ = gtk_builder_get_object (self->priv->builder, "table_main"), GTK_IS_TABLE (_tmp2_) ? ((GtkTable*) _tmp2_) : NULL)), _g_object_unref0 (self->priv->table_main), _tmp3_);
	self->priv->button_save = (_tmp5_ = _g_object_ref0 ((_tmp4_ = gtk_builder_get_object (self->priv->builder, "button_save"), GTK_IS_BUTTON (_tmp4_) ? ((GtkButton*) _tmp4_) : NULL)), _g_object_unref0 (self->priv->button_save), _tmp5_);
	self->priv->button_cancel = (_tmp7_ = _g_object_ref0 ((_tmp6_ = gtk_builder_get_object (self->priv->builder, "button_cancel"), GTK_IS_BUTTON (_tmp6_) ? ((GtkButton*) _tmp6_) : NULL)), _g_object_unref0 (self->priv->button_cancel), _tmp7_);
	self->priv->entry_name = (_tmp9_ = _g_object_ref0 ((_tmp8_ = gtk_builder_get_object (self->priv->builder, "entry_name"), GTK_IS_ENTRY (_tmp8_) ? ((GtkEntry*) _tmp8_) : NULL)), _g_object_unref0 (self->priv->entry_name), _tmp9_);
	self->priv->entry_ssid = (_tmp11_ = _g_object_ref0 ((_tmp10_ = gtk_builder_get_object (self->priv->builder, "entry_ssid"), GTK_IS_ENTRY (_tmp10_) ? ((GtkEntry*) _tmp10_) : NULL)), _g_object_unref0 (self->priv->entry_ssid), _tmp11_);
	self->priv->entry_bssid = (_tmp13_ = _g_object_ref0 ((_tmp12_ = gtk_builder_get_object (self->priv->builder, "entry_bssid"), GTK_IS_ENTRY (_tmp12_) ? ((GtkEntry*) _tmp12_) : NULL)), _g_object_unref0 (self->priv->entry_bssid), _tmp13_);
	self->priv->checkbutton_autoconnect = (_tmp15_ = _g_object_ref0 ((_tmp14_ = gtk_builder_get_object (self->priv->builder, "checkbutton_autoconnect"), GTK_IS_CHECK_BUTTON (_tmp14_) ? ((GtkCheckButton*) _tmp14_) : NULL)), _g_object_unref0 (self->priv->checkbutton_autoconnect), _tmp15_);
	self->priv->checkbutton_share_settings = (_tmp17_ = _g_object_ref0 ((_tmp16_ = gtk_builder_get_object (self->priv->builder, "checkbutton_share_settings"), GTK_IS_CHECK_BUTTON (_tmp16_) ? ((GtkCheckButton*) _tmp16_) : NULL)), _g_object_unref0 (self->priv->checkbutton_share_settings), _tmp17_);
}


static void _edit_connection_dialog_on_button_save_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	edit_connection_dialog_on_button_save_clicked (self);
}


static void _edit_connection_dialog_on_button_cancel_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	edit_connection_dialog_on_button_cancel_clicked (self);
}


static void edit_connection_dialog_connect_signals (EditConnectionDialog* self) {
	g_return_if_fail (self != NULL);
	g_signal_connect_object (self->priv->button_save, "clicked", (GCallback) _edit_connection_dialog_on_button_save_clicked_gtk_button_clicked, self, 0);
	g_signal_connect_object (self->priv->button_cancel, "clicked", (GCallback) _edit_connection_dialog_on_button_cancel_clicked_gtk_button_clicked, self, 0);
}


static void edit_connection_dialog_update_widget_values (EditConnectionDialog* self) {
	char* name;
	char* ssid;
	char* bssid;
	WirelessMode mode;
	gboolean autoconnect;
	gboolean share_settings;
	g_return_if_fail (self != NULL);
	name = g_strdup (wifi_connection_get_name (self->priv->connection));
	ssid = g_strdup (wifi_connection_get_ssid (self->priv->connection));
	bssid = g_strdup (wifi_connection_get_bssid (self->priv->connection));
	mode = wifi_connection_get_mode (self->priv->connection);
	autoconnect = wifi_connection_get_autoconnect (self->priv->connection);
	share_settings = wifi_connection_get_share_settings (self->priv->connection);
	if (name == NULL) {
		gtk_entry_set_text (self->priv->entry_name, "");
	} else {
		gtk_entry_set_text (self->priv->entry_name, name);
	}
	if (ssid == NULL) {
		gtk_entry_set_text (self->priv->entry_ssid, "");
	} else {
		gtk_entry_set_text (self->priv->entry_ssid, ssid);
	}
	if (bssid == NULL) {
		gtk_entry_set_text (self->priv->entry_bssid, "");
	} else {
		gtk_entry_set_text (self->priv->entry_bssid, bssid);
	}
	gtk_combo_box_set_active (self->priv->combobox_mode, (gint) mode);
	gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->checkbutton_autoconnect, autoconnect);
	gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->checkbutton_share_settings, share_settings);
	_g_free0 (bssid);
	_g_free0 (ssid);
	_g_free0 (name);
}


static void edit_connection_dialog_save_widget_values (EditConnectionDialog* self) {
	char* name;
	char* ssid;
	char* bssid;
	WirelessMode mode;
	gboolean autoconnect;
	gboolean share_settings;
	g_return_if_fail (self != NULL);
	name = g_strdup (gtk_entry_get_text (self->priv->entry_name));
	ssid = g_strdup (gtk_entry_get_text (self->priv->entry_ssid));
	bssid = g_strdup (gtk_entry_get_text (self->priv->entry_bssid));
	mode = (WirelessMode) gtk_combo_box_get_active (self->priv->combobox_mode);
	autoconnect = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->checkbutton_autoconnect);
	share_settings = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->checkbutton_share_settings);
	if (_vala_strcmp0 (name, "") == 0) {
		char* _tmp0_;
		name = (_tmp0_ = NULL, _g_free0 (name), _tmp0_);
	}
	if (_vala_strcmp0 (ssid, "") == 0) {
		char* _tmp1_;
		ssid = (_tmp1_ = NULL, _g_free0 (ssid), _tmp1_);
	}
	if (_vala_strcmp0 (bssid, "") == 0) {
		char* _tmp2_;
		bssid = (_tmp2_ = NULL, _g_free0 (bssid), _tmp2_);
	}
	wifi_connection_set_name (self->priv->connection, name);
	wifi_connection_set_ssid (self->priv->connection, ssid);
	wifi_connection_set_bssid (self->priv->connection, bssid);
	wifi_connection_set_mode (self->priv->connection, mode);
	wifi_connection_set_autoconnect (self->priv->connection, autoconnect);
	wifi_connection_set_share_settings (self->priv->connection, share_settings);
	_g_free0 (bssid);
	_g_free0 (ssid);
	_g_free0 (name);
}


static void edit_connection_dialog_on_button_save_clicked (EditConnectionDialog* self) {
	g_return_if_fail (self != NULL);
	edit_connection_dialog_save_widget_values (self);
	gtk_object_destroy ((GtkObject*) self->priv->dialog);
	g_signal_emit_by_name (self, "response", (gint) GTK_RESPONSE_APPLY);
}


static void edit_connection_dialog_on_button_cancel_clicked (EditConnectionDialog* self) {
	g_return_if_fail (self != NULL);
	gtk_object_destroy ((GtkObject*) self->priv->dialog);
	g_signal_emit_by_name (self, "response", (gint) GTK_RESPONSE_CANCEL);
}


gint edit_connection_dialog_run (EditConnectionDialog* self) {
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	gtk_widget_show_all ((GtkWidget*) self->priv->dialog);
	result = 0;
	return result;
}


static void edit_connection_dialog_class_init (EditConnectionDialogClass * klass) {
	edit_connection_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (EditConnectionDialogPrivate));
	G_OBJECT_CLASS (klass)->finalize = edit_connection_dialog_finalize;
	g_signal_new ("response", TYPE_EDIT_CONNECTION_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
}


static void edit_connection_dialog_instance_init (EditConnectionDialog * self) {
	char** _tmp0_ = NULL;
	self->priv = EDIT_CONNECTION_DIALOG_GET_PRIVATE (self);
	self->priv->hint_labels = (_tmp0_ = g_new0 (char*, 4 + 1), _tmp0_[0] = g_strdup ("label_hint_name"), _tmp0_[1] = g_strdup ("label_hint_ssid"), _tmp0_[2] = g_strdup ("label_hint_bssid"), _tmp0_[3] = g_strdup ("label_hint_mode"), _tmp0_);
	self->priv->hint_labels_length1 = 4;
	self->priv->_hint_labels_size_ = self->priv->hint_labels_length1;
}


static void edit_connection_dialog_finalize (GObject* obj) {
	EditConnectionDialog * self;
	self = EDIT_CONNECTION_DIALOG (obj);
	_g_object_unref0 (self->priv->connection);
	_g_object_unref0 (self->priv->builder);
	_g_object_unref0 (self->priv->dialog);
	_g_object_unref0 (self->priv->table_main);
	_g_object_unref0 (self->priv->button_save);
	_g_object_unref0 (self->priv->button_cancel);
	_g_object_unref0 (self->priv->entry_name);
	_g_object_unref0 (self->priv->entry_ssid);
	_g_object_unref0 (self->priv->entry_bssid);
	_g_object_unref0 (self->priv->combobox_mode);
	_g_object_unref0 (self->priv->checkbutton_autoconnect);
	_g_object_unref0 (self->priv->checkbutton_share_settings);
	self->priv->hint_labels = (_vala_array_free (self->priv->hint_labels, self->priv->hint_labels_length1, (GDestroyNotify) g_free), NULL);
	G_OBJECT_CLASS (edit_connection_dialog_parent_class)->finalize (obj);
}


GType edit_connection_dialog_get_type (void) {
	static volatile gsize edit_connection_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&edit_connection_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EditConnectionDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) edit_connection_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditConnectionDialog), 0, (GInstanceInitFunc) edit_connection_dialog_instance_init, NULL };
		GType edit_connection_dialog_type_id;
		edit_connection_dialog_type_id = g_type_register_static (G_TYPE_OBJECT, "EditConnectionDialog", &g_define_type_info, 0);
		g_once_init_leave (&edit_connection_dialog_type_id__volatile, edit_connection_dialog_type_id);
	}
	return edit_connection_dialog_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




